import .bool
import .connectives
import .leibniz
import .logic
import .nat
def bigops.sameF_upto : forall (A : Type) , (nat.nat) -> ((nat.nat) -> A) -> ((nat.nat) -> A) -> Prop := fun (A : Type) , fun (k : nat.nat) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , forall (i:nat.nat) , ((((nat.lt_) ) (i)) (k)) -> (((logic.eq_) (A)) ((f) (i))) ((g) (i)).
def bigops.sameF_p : forall (A : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> ((nat.nat) -> A) -> ((nat.nat) -> A) -> Prop := fun (A : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , forall (i:nat.nat) , ((((nat.lt_) ) (i)) (k)) -> ((((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) -> (((logic.eq_) (A)) ((f) (i))) ((g) (i)).
theorem bigops.sameF_upto_le : forall (A : Type) , forall (f:(nat.nat) -> A) , forall (g:(nat.nat) -> A) , forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> (((((bigops.sameF_upto) (A)) (m)) (f)) (g)) -> ((((bigops.sameF_upto) (A)) (n)) (f)) (g) := fun (A : Type) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (fun (samef : ((((bigops.sameF_upto) (A)) (m)) (f)) (g)) , (fun (i : nat.nat) , fun (ltin : (((nat.lt_) ) (i)) (n)) , (((samef) (i)) ((((((@nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))))).
theorem bigops.sameF_p_le : forall (A : Type) , forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> A) , forall (g:(nat.nat) -> A) , forall (n:nat.nat) , forall (m:nat.nat) , ((((nat.le_) ) (n)) (m)) -> ((((((bigops.sameF_p) (A)) (m)) (p)) (f)) (g)) -> (((((bigops.sameF_p) (A)) (n)) (p)) (f)) (g) := fun (A : Type) , fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> A) , fun (g : (nat.nat) -> A) , fun (n : nat.nat) , fun (m : nat.nat) , fun (lenm : (((nat.le_) ) (n)) (m)) , (fun (samef : (((((bigops.sameF_p) (A)) (m)) (p)) (f)) (g)) , (fun (i : nat.nat) , fun (ltin : (((nat.lt_) ) (i)) (n)) , (fun (pi : (((logic.eq_) (bool.bool)) ((p) (i))) ((bool.true) )) , ((((samef) (i)) ((((((@nat.lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (i))) (pi)))))).
constant bigops.bigop : forall (H : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H.
constant bigops.bigop_body : forall (H : Type) , (nat.nat) -> ((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H.
axiom bigops.axiom_bigop_O : forall (H : Type) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) )).
theorem bigops.eq_bigop_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) )) := fun (H : Type) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) ))) ((@bigops.axiom_bigop_O) (H)).
theorem bigops.sym_eq_bigop_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (((bigops.bigop) (H)) ((nat.O) )) := fun (H : Type) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) ((nat.O) ))) (((bigops.bigop_body) (H)) ((nat.O) ))) ((@bigops.eq_bigop_O) (H)).
axiom bigops.axiom_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))).
theorem bigops.eq_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((@bigops.axiom_bigop_S) (H)) (n)).
theorem bigops.sym_eq_bigop_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((bigops.bigop) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop) (H)) (((nat.S) ) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (((@bigops.eq_bigop_S) (H)) (n)).
axiom bigops.axiom_bigop_body_O : forall (H : Type) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil).
theorem bigops.eq_bigop_body_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil) := fun (H : Type) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) ((@bigops.axiom_bigop_body_O) (H)).
theorem bigops.sym_eq_bigop_body_O : forall (H : Type) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) (((bigops.bigop_body) (H)) ((nat.O) )) := fun (H : Type) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) ((nat.O) ))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , nil)) ((@bigops.eq_bigop_body_O) (H)).
axiom bigops.axiom_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((connectives.equal) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n))).
theorem bigops.eq_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@connectives.equal_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((@bigops.axiom_bigop_body_S) (H)) (n)).
theorem bigops.sym_eq_bigop_body_S : forall (H : Type) , forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((bigops.bigop_body) (H)) (((nat.S) ) (n))) := fun (H : Type) , fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (((nat.nat) -> bool.bool) -> (H) -> ((H) -> (H) -> H) -> ((nat.nat) -> H) -> H)) (((bigops.bigop_body) (H)) (((nat.S) ) (n)))) (fun (p : (nat.nat) -> bool.bool) , fun (nil : H) , fun (op : (H) -> (H) -> H) , fun (f : (nat.nat) -> H) , ((((bool.match_bool_type) (H)) (((op) ((f) (n))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f)))) (((((((bigops.bigop) (H)) (n)) (p)) (nil)) (op)) (f))) ((p) (n)))) (((@bigops.eq_bigop_body_S) (H)) (n)).
theorem bigops.bigop_Strue : forall (B : Type) , forall (k:nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (k))) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) := fun (B : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , ((((@bigops.sym_eq_bigop_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) (fun (H : (((logic.eq_) (bool.bool)) ((p) (k))) ((bool.true) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (x))) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))))) ((((((@bool.eq_match_bool_type_true) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.true) ))) (y))) (((@logic.refl_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.true) ))))) ((p) (k))) (H)))).
theorem bigops.bigop_Sfalse : forall (B : Type) , forall (k:nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (k))) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))) := fun (B : Type) , fun (k : nat.nat) , fun (p : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , ((((@bigops.sym_eq_bigop_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (k)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (fun (H : (((logic.eq_) (bool.bool)) ((p) (k))) ((bool.false) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (x))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) ((((((@bool.eq_match_bool_type_false) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.false) ))) (y))) (((@logic.refl_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (k))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((bool.false) ))))) ((p) (k))) (H)))).
theorem bigops.same_bigop : forall (B : Type) , forall (k:nat.nat) , forall (p1:(nat.nat) -> bool.bool) , forall (p2:(nat.nat) -> bool.bool) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , forall (g:(nat.nat) -> B) , (((((bigops.sameF_upto) (bool.bool)) (k)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (k)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (k)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))) := fun (B : Type) , fun (k : nat.nat) , fun (p1 : (nat.nat) -> bool.bool) , fun (p2 : (nat.nat) -> bool.bool) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , fun (g : (nat.nat) -> B) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((((bigops.sameF_upto) (bool.bool)) (_x_365)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (_x_365)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (_x_365)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (_x_365)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.sym_eq_bigop_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.sym_eq_bigop_body_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) ((((@bigops.eq_bigop_body_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.eq_bigop_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (fun (auto : ((((bigops.sameF_upto) (bool.bool)) ((nat.O) )) (p1)) (p2)) , (fun (auto' : (((((bigops.sameF_p) (B)) ((nat.O) )) (p1)) (f)) (g)) , (((@logic.refl_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))))))))) (fun (n : nat.nat) , ((((@bigops.sym_eq_bigop_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop_body) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((y) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop_body) (B)) (((nat.S) ) (n))) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((@bigops.sym_eq_bigop_body_S) (B)) (n)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , ((((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) -> (((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) -> (((logic.eq_) (B)) ((((((fun (p : (nat.nat) -> bool.bool) , fun (nil0 : B) , fun (op0 : (B) -> (B) -> B) , fun (f0 : (nat.nat) -> B) , ((((bool.match_bool_type) (B)) (((op0) ((f0) (n))) (((((((bigops.bigop) (B)) (n)) (p)) (nil0)) (op0)) (f0)))) (((((((bigops.bigop) (B)) (n)) (p)) (nil0)) (op0)) (f0))) ((p) (n))) (fun (i : nat.nat) , (p1) (i)))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (fun (Hind : (((((bigops.sameF_upto) (bool.bool)) (n)) (p1)) (p2)) -> ((((((bigops.sameF_p) (B)) (n)) (p1)) (f)) (g)) -> (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) , (fun (samep : ((((bigops.sameF_upto) (bool.bool)) (((nat.S) ) (n))) (p1)) (p2)) , (fun (samef : (((((bigops.sameF_p) (B)) (((nat.S) ) (n))) (p1)) (f)) (g)) , (((((((@logic.eq_ind_r) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (x : B) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (x))) (x)) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p2) (n))))) (((((((@logic.eq_ind) (bool.bool)) ((p1) (n))) (fun (x_1 : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x_1)))) (((((((@connectives.match_Or_prop) ((((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.true) ))) ((((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.false) ))) ((((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n)))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((p1) (n))))) (fun (H1 : (((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.true) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x)))) ((((((@bool.sym_eq_match_bool_type_true) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (y)) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((bool.true) )))) ((((((@bool.sym_eq_match_bool_type_true) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (y))) (((((((@logic.eq_ind) (B)) ((f) (n))) (fun (x_1 : B) , (((logic.eq_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((op) (x_1)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))))) (((@logic.refl_) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))))) ((g) (n))) ((((samef) (n)) ((@nat.le_n) (((nat.S) ) (n)))) (H1)))))) ((p1) (n))) (H1)))) (fun (H1 : (((logic.eq_) (bool.bool)) ((p1) (n))) ((bool.false) )) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (B)) (((((bool.match_bool_type) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x))) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (x)))) ((((((@bool.sym_eq_match_bool_type_false) (B)) (((op) ((f) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (y)) (((((bool.match_bool_type) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) ((bool.false) )))) ((((((@bool.sym_eq_match_bool_type_false) (B)) (((op) ((g) (n))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (fun (y : B) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i)))) (y))) (((@logic.refl_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p2) (i))) (nil)) (op)) (fun (i : nat.nat) , (g) (i))))))) ((p1) (n))) (H1)))) ((@bool.true_or_false) ((p1) (n))))) ((p2) (n))) (((samep) (n)) ((@nat.le_n) (((nat.S) ) (n)))))) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (p1) (i))) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((Hind) ((((((((@bigops.sameF_upto_le) (bool.bool)) (p1)) (p2)) (n)) (((nat.S) ) (n))) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (n)))) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n)))) ((@nat.le_pred_n) (((nat.S) ) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (n)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((nat.pred_) ) (((nat.S) ) (n)))) ((@nat.pred_Sn) (n))))) (samep))) (((((((((@bigops.sameF_p_le) (B)) (p1)) (f)) (g)) (n)) (((nat.S) ) (n))) (((((@logic.eq_coerc) ((((nat.le_) ) (((nat.pred_) ) (((nat.S) ) (n)))) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n)))) ((@nat.le_pred_n) (((nat.S) ) (n)))) (((((((@logic.rewrite_l) (nat.nat)) (n)) (fun (__ : nat.nat) , (((logic.eq_) (Prop)) ((((nat.le_) ) (__)) (((nat.S) ) (n)))) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((@logic.refl_) (Prop)) ((((nat.le_) ) (n)) (((nat.S) ) (n))))) (((nat.pred_) ) (((nat.S) ) (n)))) ((@nat.pred_Sn) (n))))) (samef)))))))))))) (k).
theorem bigops.bigop_false : forall (B : Type) , forall (n:nat.nat) , forall (nil:B) , forall (op:(B) -> (B) -> B) , forall (f:(nat.nat) -> B) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n)) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (nil) := fun (B : Type) , fun (n : nat.nat) , fun (nil : B) , fun (op : (B) -> (B) -> B) , fun (f : (nat.nat) -> B) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (_x_365)) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (nil))) ((((@bigops.eq_bigop_body_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.eq_bigop_O) (B)) (fun (y : ((nat.nat) -> bool.bool) -> (B) -> ((B) -> (B) -> B) -> ((nat.nat) -> B) -> B) , (((logic.eq_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (((((y) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))) (((@logic.refl_) (B)) (((((((bigops.bigop) (B)) ((nat.O) )) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i))))))) (fun (n1 : nat.nat) , fun (Hind : (((logic.eq_) (B)) (((((((bigops.bigop) (B)) (n1)) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (nil)) , (((((((@logic.eq_ind_r) (B)) (((((((bigops.bigop) (B)) (n1)) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (fun (x : B) , (((logic.eq_) (B)) (x)) (nil))) (((((((@logic.rewrite_r) (B)) (nil)) (fun (__ : B) , (((logic.eq_) (B)) (__)) (nil))) (((@logic.refl_) (B)) (nil))) (((((((bigops.bigop) (B)) (n1)) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) (Hind))) (((((((bigops.bigop) (B)) (((nat.S) ) (n1))) (fun (i : nat.nat) , (bool.false) )) (nil)) (op)) (fun (i : nat.nat) , (f) (i)))) ((((((((@bigops.bigop_Sfalse) (B)) (n1)) (fun (__ : nat.nat) , (bool.false) )) (nil)) (op)) (f)) (((@logic.refl_) (bool.bool)) ((bool.false) )))))) (n).
theorem bigops.bigop_I_gen : forall (a:nat.nat) , forall (b:nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b)) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (b)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (b)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))) := fun (a : nat.nat) , fun (b : nat.nat) , ((((@nat.nat_ind) (fun (_x_365 : nat.nat) , forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (_x_365)) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (_x_365)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (_x_365)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> nat.nat) , (((@bigops.sym_eq_bigop_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((y) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.sym_eq_bigop_body_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((y) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.eq_bigop_body_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((y) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) ((((@bigops.eq_bigop_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((y) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) (((@nat.eq_minus_body_O) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) ((y) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) (((((@nat.eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) ((y) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) ((((@nat.eq_minus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) ((nat.O) )) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) ((y) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) (fun (auto : (((nat.le_) ) (a)) ((nat.O) )) , (((@logic.refl_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) ((nat.O) )) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))))))))))) (fun (b0 : nat.nat) , fun (Hind : forall (p:(nat.nat) -> bool.bool) , forall (f:(nat.nat) -> nat.nat) , ((((nat.le_) ) (a)) (b0)) -> (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) , (fun (p : (nat.nat) -> bool.bool) , fun (f : (nat.nat) -> nat.nat) , fun (lea : (((nat.le_) ) (a)) (((nat.S) ) (b0))) , (((((((@connectives.match_Or_prop) ((((nat.lt_) ) (a)) (((nat.S) ) (b0)))) ((((logic.eq_) (nat.nat)) (a)) (((nat.S) ) (b0)))) ((((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (b0))) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (fun (Ha : (((nat.lt_) ) (a)) (((nat.S) ) (b0))) , (((((((@connectives.match_Or_prop) ((((logic.eq_) (bool.bool)) ((p) (b0))) ((bool.true) ))) ((((logic.eq_) (bool.bool)) ((p) (b0))) ((bool.false) ))) ((((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (b0))) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (fun (Hcase : (((logic.eq_) (bool.bool)) ((p) (b0))) ((bool.true) )) , (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) (b0))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (x))) (((((((@logic.eq_ind_r) (nat.nat)) (((nat.S) ) ((((nat.minus) ) (b0)) (a)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (x)) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) ((((nat.times) ) ((f) (b0))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.times) ) ((f) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a)))) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a)))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) ((((nat.times) ) ((f) (b0))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))))) (((((((((((@logic.eq_f2) (nat.nat)) (nat.nat)) (nat.nat)) ((nat.times) )) ((f) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a)))) ((f) (b0))) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) (((((((@logic.eq_f) (nat.nat)) (nat.nat)) (f)) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a))) (b0)) (((((((@logic.eq_ind) (nat.nat)) (b0)) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) (x_1)) (b0))) (((@logic.refl_) (nat.nat)) (b0))) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a))) ((((@nat.plus_minus_m_m) (b0)) (a)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha)))))) ((((Hind) (p)) (f)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) ((((nat.minus) ) (b0)) (a)))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) ((((((((@bigops.bigop_Strue) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (__ : nat.nat) , (p) ((((nat.plus) ) (__)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (__ : nat.nat) , (f) ((((nat.plus) ) (__)) (a)))) (((((((@logic.eq_ind) (nat.nat)) (b0)) (fun (x_1 : nat.nat) , (((logic.eq_) (bool.bool)) ((p) (x_1))) ((bool.true) ))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.true) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.true) ))) (((@logic.refl_) (bool.bool)) ((bool.true) ))) ((p) (b0))) (Hcase))) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a))) ((((@nat.plus_minus_m_m) (b0)) (a)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))))) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) ((((((@nat.match_nat_prop) (fun (__ : nat.nat) , ((((nat.le_) ) (__)) (b0)) -> (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (__))) (((nat.S) ) ((((nat.minus) ) (b0)) (__))))) (fun (auto : (((nat.le_) ) ((nat.O) )) (b0)) , (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) (b0))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.minus) ) (b0)) ((nat.O) ))))) (((((((@logic.rewrite_l) (nat.nat)) (b0)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (b0))) (((nat.S) ) (__)))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (b0)))) ((((nat.minus) ) (b0)) ((nat.O) ))) ((@nat.minus_n_O) (b0)))) ((((nat.minus) ) (((nat.S) ) (b0))) ((nat.O) ))) ((@nat.minus_n_O) (((nat.S) ) (b0)))))) ((((@nat.sym_eq_minus) (((nat.S) ) (b0))) (fun (y : (nat.nat) -> nat.nat) , forall (n:nat.nat) , ((((nat.le_) ) (((nat.S) ) (n))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (n)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (n)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (b0)) (fun (y : (nat.nat) -> nat.nat) , forall (n:nat.nat) , ((((nat.le_) ) (((nat.S) ) (n))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (n)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (n)))))) (fun (a1 : nat.nat) , (((@nat.sym_eq_minus_body_S) (b0)) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (((nat.S) ) (a1))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (a1)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))))) (((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) (((nat.S) ) (b0))) (fun (q : nat.nat) , (((nat.minus) ) (b0)) (q))) (a1)) (fun (y : nat.nat) , ((((nat.le_) ) (((nat.S) ) (a1))) (b0)) -> (((logic.eq_) (nat.nat)) (y)) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))))) (fun (lta1 : (((nat.le_) ) (((nat.S) ) (a1))) (b0)) , (((((((@logic.eq_ind_r) (nat.nat)) (((nat.pred_) ) ((((nat.minus) ) (b0)) (a1)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (((nat.S) ) (x)))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (x))) (((@logic.refl_) (nat.nat)) ((((nat.minus) ) (b0)) (a1)))) (((nat.S) ) (((nat.pred_) ) ((((nat.minus) ) (b0)) (a1))))) (((@nat.S_pred) ((((nat.minus) ) (b0)) (a1))) (((((@nat.lt_plus_to_minus_r) ((nat.O) )) (a1)) (b0)) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (lta1)))))))) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))) (((@nat.eq_minus_S_pred) (b0)) (a1))))))))) (a)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (b0))) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) ((((((((@bigops.bigop_Strue) (nat.nat)) (b0)) (fun (__ : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (__))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) ((((nat.leb) ) (a)) (b0))) (x))) ((bool.true) ))) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.true) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (x)) ((bool.true) ))) ((bool.true) ))) ((((((@bool.eq_match_bool_type_true) (bool.bool)) ((bool.true) )) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((bool.true) )) ((bool.false) )) ((bool.true) ))) (y))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) ((bool.true) )) ((bool.true) ))))) ((((nat.leb) ) (a)) (b0))) ((((@nat.le_to_leb_true) (a)) (b0)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))) ((p) (b0))) (Hcase)))))) (fun (Hcase : (((logic.eq_) (bool.bool)) ((p) (b0))) ((bool.false) )) , (((((((@logic.eq_ind_r) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (x))) (((((((@logic.eq_ind_r) (nat.nat)) (((nat.S) ) ((((nat.minus) ) (b0)) (a)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (x)) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (((((((@logic.eq_ind_r) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) (x)) (((((((bigops.bigop) (nat.nat)) (b0)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) ((((Hind) (p)) (f)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha)))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) ((((nat.minus) ) (b0)) (a)))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) ((((((((@bigops.bigop_Sfalse) (nat.nat)) ((((nat.minus) ) (b0)) (a))) (fun (__ : nat.nat) , (p) ((((nat.plus) ) (__)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (__ : nat.nat) , (f) ((((nat.plus) ) (__)) (a)))) (((((((@logic.eq_ind) (nat.nat)) (b0)) (fun (x_1 : nat.nat) , (((logic.eq_) (bool.bool)) ((p) (x_1))) ((bool.false) ))) (((((((@logic.rewrite_r) (bool.bool)) ((bool.false) )) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) (__)) ((bool.false) ))) (((@logic.refl_) (bool.bool)) ((bool.false) ))) ((p) (b0))) (Hcase))) ((((nat.plus) ) ((((nat.minus) ) (b0)) (a))) (a))) ((((@nat.plus_minus_m_m) (b0)) (a)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))))) ((((nat.minus) ) (((nat.S) ) (b0))) (a))) ((((((@nat.match_nat_prop) (fun (__ : nat.nat) , ((((nat.le_) ) (__)) (b0)) -> (((logic.eq_) (nat.nat)) ((((nat.minus) ) (((nat.S) ) (b0))) (__))) (((nat.S) ) ((((nat.minus) ) (b0)) (__))))) (fun (auto : (((nat.le_) ) ((nat.O) )) (b0)) , (((((((@logic.rewrite_l) (nat.nat)) (((nat.S) ) (b0))) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (__)) (((nat.S) ) ((((nat.minus) ) (b0)) ((nat.O) ))))) (((((((@logic.rewrite_l) (nat.nat)) (b0)) (fun (__ : nat.nat) , (((logic.eq_) (nat.nat)) (((nat.S) ) (b0))) (((nat.S) ) (__)))) (((@logic.refl_) (nat.nat)) (((nat.S) ) (b0)))) ((((nat.minus) ) (b0)) ((nat.O) ))) ((@nat.minus_n_O) (b0)))) ((((nat.minus) ) (((nat.S) ) (b0))) ((nat.O) ))) ((@nat.minus_n_O) (((nat.S) ) (b0)))))) ((((@nat.sym_eq_minus) (((nat.S) ) (b0))) (fun (y : (nat.nat) -> nat.nat) , forall (n:nat.nat) , ((((nat.le_) ) (((nat.S) ) (n))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (n)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (n)))))) ((((((@nat.sym_eq_filter_nat_type_S) ((nat.nat) -> nat.nat)) ((nat.minus_body) )) (b0)) (fun (y : (nat.nat) -> nat.nat) , forall (n:nat.nat) , ((((nat.le_) ) (((nat.S) ) (n))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (n)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (n)))))) (fun (a1 : nat.nat) , (((@nat.sym_eq_minus_body_S) (b0)) (fun (y : (nat.nat) -> nat.nat) , ((((nat.le_) ) (((nat.S) ) (a1))) (b0)) -> (((logic.eq_) (nat.nat)) ((y) (((nat.S) ) (a1)))) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))))) (((((((@nat.sym_eq_match_nat_type_S) (nat.nat)) (((nat.S) ) (b0))) (fun (q : nat.nat) , (((nat.minus) ) (b0)) (q))) (a1)) (fun (y : nat.nat) , ((((nat.le_) ) (((nat.S) ) (a1))) (b0)) -> (((logic.eq_) (nat.nat)) (y)) (((nat.S) ) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))))) (fun (lta1 : (((nat.le_) ) (((nat.S) ) (a1))) (b0)) , (((((((@logic.eq_ind_r) (nat.nat)) (((nat.pred_) ) ((((nat.minus) ) (b0)) (a1)))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (((nat.S) ) (x)))) (((((((@logic.eq_ind_r) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (fun (x : nat.nat) , (((logic.eq_) (nat.nat)) ((((nat.minus) ) (b0)) (a1))) (x))) (((@logic.refl_) (nat.nat)) ((((nat.minus) ) (b0)) (a1)))) (((nat.S) ) (((nat.pred_) ) ((((nat.minus) ) (b0)) (a1))))) (((@nat.S_pred) ((((nat.minus) ) (b0)) (a1))) (((((@nat.lt_plus_to_minus_r) ((nat.O) )) (a1)) (b0)) ((((@nat.sym_eq_plus) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.plus_body) )) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (((@nat.sym_eq_plus_body_O) (fun (y : (nat.nat) -> nat.nat) , (((nat.le_) ) (((nat.S) ) ((y) (a1)))) (b0))) (lta1)))))))) ((((nat.minus) ) (b0)) (((nat.S) ) (a1)))) (((@nat.eq_minus_S_pred) (b0)) (a1))))))))) (a)) ((((@nat.le_S_S_to_le) (a)) (b0)) (Ha))))) (((((((bigops.bigop) (nat.nat)) (((nat.S) ) (b0))) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) ((((((((@bigops.bigop_Sfalse) (nat.nat)) (b0)) (fun (__ : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (__))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) ((((nat.leb) ) (a)) (b0))) (x))) ((bool.false) ))) (((((@bool.match_bool_prop) (fun (__ : bool.bool) , (((logic.eq_) (bool.bool)) ((((bool.andb) ) (__)) ((bool.false) ))) ((bool.false) ))) ((((((@bool.eq_match_bool_type_true) (bool.bool)) ((bool.false) )) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.false) )) ((bool.true) ))) (y))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) ((bool.true) )) ((bool.false) ))))) ((((((@bool.eq_match_bool_type_false) (bool.bool)) ((bool.false) )) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) (((((bool.match_bool_type) (bool.bool)) ((bool.false) )) ((bool.false) )) ((bool.false) ))) (y))) (((@logic.refl_) (bool.bool)) ((((bool.andb) ) ((bool.false) )) ((bool.false) ))))) ((((nat.leb) ) (a)) (b0)))) ((p) (b0))) (Hcase)))))) ((@bool.true_or_false) ((p) (b0)))))) (fun (Ha : (((logic.eq_) (nat.nat)) (a)) (((nat.S) ) (b0))) , (((((((@logic.eq_ind) (nat.nat)) (a)) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) ((((nat.minus) ) (x_1)) (a))) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (x_1)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (((((((@logic.eq_ind) (nat.nat)) ((nat.O) )) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (x_1)) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (a)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.sym_eq_bigop_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((((y) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (a)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) ((((@bigops.sym_eq_bigop_body_O) (nat.nat)) (fun (y : ((nat.nat) -> bool.bool) -> (nat.nat) -> ((nat.nat) -> (nat.nat) -> nat.nat) -> ((nat.nat) -> nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) (((((y) (fun (i : nat.nat) , (p) ((((nat.plus) ) (i)) (a)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) ((((nat.plus) ) (i)) (a))))) (((((((bigops.bigop) (nat.nat)) (a)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (((((((@logic.eq_ind) (nat.nat)) (((((((bigops.bigop) (nat.nat)) (a)) (fun (i : nat.nat) , (bool.false) )) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i)))) (fun (x_1 : nat.nat) , (((logic.eq_) (nat.nat)) (x_1)) (((((((bigops.bigop) (nat.nat)) (a)) (fun (i : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (i))) ((p) (i)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (fun (i : nat.nat) , (f) (i))))) (((((((((((@bigops.same_bigop) (nat.nat)) (a)) (fun (__ : nat.nat) , (bool.false) )) (fun (__ : nat.nat) , (((bool.andb) ) ((((nat.leb) ) (a)) (__))) ((p) (__)))) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)) (f)) (fun (i : nat.nat) , fun (ltia : (((nat.lt_) ) (i)) (a)) , (((((((@logic.eq_ind_r) (bool.bool)) ((bool.false) )) (fun (x : bool.bool) , (((logic.eq_) (bool.bool)) ((bool.false) )) ((((bool.andb) ) (x)) ((p) (i))))) ((((((@bool.sym_eq_match_bool_type_false) (bool.bool)) ((p) (i))) ((bool.false) )) (fun (y : bool.bool) , (((logic.eq_) (bool.bool)) ((bool.false) )) (y))) (((@logic.refl_) (bool.bool)) ((bool.false) )))) ((((nat.leb) ) (a)) (i))) ((((@nat.not_le_to_leb_false) (a)) (i)) ((((@nat.lt_to_not_le) (i)) (a)) (ltia)))))) (fun (i : nat.nat) , fun (auto : (((nat.lt_) ) (i)) (a)) , (fun (auto' : (((logic.eq_) (bool.bool)) ((bool.false) )) ((bool.true) )) , (((@logic.refl_) (nat.nat)) ((f) (i))))))) (((nat.S) ) ((nat.O) ))) ((((((@bigops.bigop_false) (nat.nat)) (a)) (((nat.S) ) ((nat.O) ))) ((nat.times) )) (f)))))) ((((nat.minus) ) (a)) (a))) ((@nat.minus_n_n) (a)))) (((nat.S) ) (b0))) (Ha)))) ((((@nat.le_to_or_lt_eq) (a)) (((nat.S) ) (b0))) (lea)))))) (b).
